package som.interpreter;

import java.io.IOException;

import com.oracle.truffle.api.CallTarget;
import com.oracle.truffle.api.Truffle;
import com.oracle.truffle.api.TruffleLanguage;
import com.oracle.truffle.api.debug.DebuggerTags.AlwaysHalt;
import com.oracle.truffle.api.instrumentation.ProvidedTags;
import com.oracle.truffle.api.instrumentation.StandardTags.CallTag;
import com.oracle.truffle.api.instrumentation.StandardTags.RootTag;
import com.oracle.truffle.api.instrumentation.StandardTags.StatementTag;
import com.oracle.truffle.api.source.Source;


@TruffleLanguage.Registration(id = "SOMns", name = "SOMns", version = "0.1.0",
    interactive = false, internal = false,
    mimeType = "application/x-newspeak-som-ns")
@ProvidedTags({
    RootTag.class, StatementTag.class, CallTag.class,

    AlwaysHalt.class,

})
public final class SomLanguage extends TruffleLanguage<Object> {

  public static final String MIME_TYPE          = "application/x-newspeak-som-ns";
  public static final String VM_OBJECT          = "vm-object";
  public static final String FILE_EXTENSION     = "ns";
  public static final String DOT_FILE_EXTENSION = "." + FILE_EXTENSION;

  public static Source getSyntheticSource(final String text, final String name) {
    return Source.newBuilder(text).internal().name(name).mimeType(SomLanguage.MIME_TYPE)
                 .build();
  }

  @Override
  protected Object createContext(final Env env) {
    return null;
  }

  @Override
  protected void disposeContext(final Object context) {

  }

  @Override
  protected CallTarget parse(final ParsingRequest request) throws IOException {

    try {
      return Truffle.getRuntime().createCallTarget(null);
    } catch (ThreadDeath t) {
      throw new IOException(t);
    }
  }

  @Override
  protected Object findExportedSymbol(final Object context, final String globalName,
      final boolean onlyExplicit) {
    return null;
  }

  @Override
  protected Object getLanguageGlobal(final Object context) {
    return null;
  }

  @Override
  protected boolean isObjectOfLanguage(final Object object) {
    return true;
  }

  @Override
  protected boolean isThreadAccessAllowed(final Thread thread, final boolean singleThreaded) {
    return true;
  }
}
