package som.primitives;

import java.util.concurrent.ForkJoinPool;

import com.oracle.truffle.api.CompilerDirectives.CompilationFinal;
import com.oracle.truffle.api.dsl.GenerateNodeFactory;
import com.oracle.truffle.api.dsl.ImportStatic;
import com.oracle.truffle.api.dsl.NodeChild;

import som.interpreter.Primitive;
import som.interpreter.nodes.nary.TernaryExpressionNode;
import som.primitives.arrays.ToArgumentsArrayNode;
import som.primitives.arrays.ToArgumentsArrayNodeFactory;


public abstract class ActivitySpawn {

  @GenerateNodeFactory
  @ImportStatic({ActivitySpawn.class})
  @NodeChild(value = "argArr", type = ToArgumentsArrayNode.class,
      executeWith = {"secondArg", "firstArg"})
  @Primitive(primitive = "threading:threadSpawn:with:",
      extraChild = ToArgumentsArrayNodeFactory.class)
  @Primitive(primitive = "threading:taskSpawn:with:",
      extraChild = ToArgumentsArrayNodeFactory.class)
  @Primitive(primitive = "proc:spawn:with:", extraChild = ToArgumentsArrayNodeFactory.class)
  @Primitive(selector = "spawn:with:", extraChild = ToArgumentsArrayNodeFactory.class)
  public abstract static class SpawnWithPrim extends TernaryExpressionNode {
    @CompilationFinal private ForkJoinPool forkJoinPool;
    @CompilationFinal private ForkJoinPool processesPool;
    @CompilationFinal private ForkJoinPool threadPool;

  }
}
