package som.primitives.arrays;

import com.oracle.truffle.api.dsl.GenerateNodeFactory;
import com.oracle.truffle.api.dsl.NodeChild;
import com.oracle.truffle.api.dsl.NodeChildren;
import com.oracle.truffle.api.dsl.Specialization;

import som.interpreter.nodes.ExpressionNode;
import som.vmobjects.SAbstractObject;


@GenerateNodeFactory
@NodeChildren({
    @NodeChild("somArray"),
    @NodeChild("receiver")})
public abstract class ToArgumentsArrayNode extends ExpressionNode {
  public static final boolean isNull(final Object somArray) {
    return somArray == null;
  }

  public abstract Object[] executedEvaluated(SAbstractObject somArray, Object rcvr);

  public final Object[] executedEvaluated(final Object somArray, final Object rcvr) {
    return executedEvaluated((SAbstractObject) somArray, rcvr);
  }

  @Specialization(guards = "isNull(somArray)")
  public final Object[] doNoArray(final Object somArray, final Object rcvr) {
    return new Object[] {rcvr};
  }

  @Specialization
  public final Object[] doEmptyArray(final SAbstractObject somArray, final Object rcvr) {
    return null;
  }
}
